#pragma option -3 -r -Z -O2 -a
#include <stdio.h>
#include <dos.h>

#define N2	10000

int h1[N2 + 1], h2[N2 + 1];
struct workspace {
	long min, cnt;
	long val[N2];
	signed char next[N2];
} far w1, far w2;

#define CUBE(x)		((x) * (x) * (long) (x))

void sift(struct workspace far *w, int *hp, int i)
{
	int tmp;

	while((i <<= 1) <= N2) {
		if((i < N2) && (w->val[hp[i]] > w->val[hp[i + 1]]))
			i++;
		if(w->val[hp[i]] >= w->val[hp[i >> 1]])
			return;
		tmp = hp[i], hp[i] = hp[i >> 1], hp[i >> 1] = tmp;
	}
}

long calc(int x, int *a)
{
	int i = x % 100 - 50;
	int j = x / 100 - 50;

	if(i >= 0)
		i++;
	if(j >= 0)
		j++;
	return(a[0] * CUBE(i) + a[1] * CUBE(j));
}

void init(int *hp, int *a, struct workspace far *w)
{
	int i, j;
	long v1, v2;

	for(i = 0; i < N2; i++) {
		hp[i + 1] = i;
		w->next[i] = -50;
		w->val[i] = calc(i, a) + a[2] * CUBE(-50);
	}
	for(i = N2 / 2; i; i--)
		sift(w, hp, i);
}

void extract(int *hp, int *a, struct workspace far *w)
{
	int x = hp[1];

	w->min = w->val[x];
	for(w->cnt = 1; ; w->cnt++) {
//		if((++w->next[x]) == 51)
			w->val[x] = 0x7FFF0000l;
/*		else {
			if(!w->next[x])
				w->next[x]++;
			w->val[x] = calc(x, a) + a[2] * CUBE(w->next[x]);
		}*/
		sift(w, hp, 1);
		x = hp[1];
		if(w->min != w->val[x])
			return;
	}
}

int main()
{
	int a[6], i;
	long todo1, todo2, cnt = 0;

	freopen("eqs.in", "r", stdin);
	for(i = 0; i < 6; i++) {
		scanf("%d", a + i);
		if(a[i] < 0)
			a[i] = -a[i];
	}
	init(h1, a, &w1);
	init(h2, a + 3, &w2);

	extract(h1, a, &w1);
	extract(h2, a + 3, &w2);
	for(todo1 = todo2 = 100l * N2; ; ) {
		if(w1.min == w2.min)
			cnt += w1.cnt * w2.cnt;
		if(w1.min <= w2.min) {
			if(!(todo1 -= w1.cnt))
				break;
			extract(h1, a, &w1);
		} else {
			if(!(todo2 -= w2.cnt))
				break;
			extract(h2, a + 3, &w2);
                }
	}
	printf("%ld\n", cnt);
	return(0);
}
