#include <stdio.h>
#include <stdlib.h>

int n;

struct el {
       int x, y;
       int nel;
};

typedef struct el huge ELEM, huge * PELEM;

typedef int (*fcmp)(const void*, const void*);

struct el huge trees[16002];

#define tr(x) (&trees[(x)])

int compare(PELEM pel1, PELEM pel2)
{
    return((pel1->x==pel2->x)&&(pel1->y==pel2->y));
}

int cmptr(const struct el *p1, const struct el *p2)
{
    if(p1->x<p2->x)
        return -1;
    else {
          if(p1->x==p2->x) {
              return p1->y-p2->y;
          } else {
              return 1;
          }
    }
}

void sort_trees(void)
{
    qsort(trees, n,  sizeof(struct el), (fcmp) cmptr);
}

int find_it(PELEM pel)
{
    PELEM rez;
    rez = (PELEM)bsearch(pel, trees, n, sizeof(struct el), (fcmp)cmptr);
    if(rez)
      return((rez->nel)+1);
    return 0;
}

int dirs[4][2]={{1, 0}, {0, 1}, {-1, 0},{0, -1}};

char viz[16001];
int que[16348];

int fill_zone(int x)
{
    int l, r, i;
    int tpos;
    PELEM elc;
    struct el nxt;
    l=r=0;
    que[0]=x;
    viz[x]=1;
    while(l<=r) {
       elc=tr(que[l]);
       for(i=0;i<4;i++) {
          nxt.x=elc->x+dirs[i][0];
          nxt.y=elc->y+dirs[i][1];
          if(nxt.x<0)
             continue;
          if(nxt.y<0)
             continue;
          tpos=find_it(&nxt);
          if(tpos) {
              tpos--;
              if(viz[tpos]==0) {
                 que[++r]=tpos;
                 viz[tpos]=1;
              }
          }
       }
       l++;
    }
    return l;
}

int cmp(const void *p1, const void *p2)
{
    int *pi1, *pi2;
    pi1=(int *)p1;
    pi2=(int *)p2;
    return(*pi2-*pi1);
}

void main(void)
{
    int i, k;
    int maxtrees;
    int zones[16001], nzones;
    FILE *pf;
    pf=fopen("banana.in", "rt");
    fscanf(pf, "%d %d", &n, &k);
    for(i=0;i<n;i++) {
       fscanf(pf, "%d %d", &trees[i].x,&trees[i].y);
    }
    fclose(pf);
    sort_trees();
    for(i=0;i<n;i++)
       trees[i].nel=i;
    nzones=0;
    for(i=0;i<n;i++)
       if(viz[i]==0)
           zones[nzones++]=fill_zone(i);
    qsort(zones, nzones, sizeof(int), cmp);
    for(maxtrees=0, i=0;i<k;i++)
        maxtrees+=zones[i];
    pf=fopen("banana.out","wt");
    fprintf(pf, "%d\n", maxtrees);
    fclose(pf);
}