#pragma option -3 -G -O2 -Z

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int far xc[16008], far yc[16008];
int far bndx[16008];

int msbuf[16008];

void mergesortx(int far *v, int n) {
	static int s1, s2, e1, e2, x;

	if(n <= 1)
		return;
	mergesortx(v, n >> 1);
	mergesortx(v + (n >> 1), n - (n >> 1));

	s1 = 0; s2 = e1 = n >> 1; e2 = n;
	for(x = 0; x < n; x++) {
		if(s1 < e1) {
			if(s2 < e2 && v[s2] < v[s1])
				msbuf[x] = v[s2++];
			else
				msbuf[x] = v[s1++];
		}
		else
			msbuf[x] = v[s2++];
	}
	_fmemcpy(v, msbuf, sizeof(int) * n);
}

void mergesortb(int far *v, int n) {
	static int s1, s2, e1, e2, x;

	if(n <= 1)
		return;
	mergesortb(v, n >> 1);
	mergesortb(v + (n >> 1), n - (n >> 1));

	s1 = 0; s2 = e1 = n >> 1; e2 = n;
	for(x = 0; x < n; x++) {
		if(s1 < e1) {
			if(s2 < e2 && (xc[v[s2]] < xc[v[s1]]) || (xc[v[s2]] == xc[v[s1]] && yc[v[s2]] < yc[v[s1]]))
				msbuf[x] = v[s2++];
			else
				msbuf[x] = v[s1++];
		}
		else
			msbuf[x] = v[s2++];
	}
	_fmemcpy(v, msbuf, sizeof(int) * n);
}

int bb_find(int px, int py, int n) {
	int l, r, x;

	l = 0; r = n - 1;
	while(l <= r) {
		x = (l + r) >> 1;
		if(xc[bndx[x]] < px)
			l = x + 1;
		else if(xc[bndx[x]] > px)
			r = x - 1;
		else {
			if(yc[bndx[x]] < py)
				l = x + 1;
			else if(yc[bndx[x]] > py)
				r = x - 1;
			else
				return x;
		}
	}
	return -1;
}

int far pi[16008], far grad[16008];
void ds_init() {
	_fmemset(pi, 0xff, sizeof(pi));
}
int ds_find(int s) {
	int r, x, w;

	x = s;
	while(pi[x] != -1)
		x = pi[x];
	r = x;
	x = s;
	while(pi[x] != -1) {
		w = pi[x];
		pi[x] = r;
		x = w;
	}
	return r;
}
void ds_union(int xa, int xb) {
	int a, b;

	a = ds_find(xa);
	b = ds_find(xb);
	if(a == b)
		return;
	if(grad[a] > grad[b])
		pi[b] = a;
	else if(grad[b] > grad[a])
		pi[a] = b;
	else {
		pi[b] = a;
		grad[a]++;
	}
}

int far gcc[16008];

int main() {
	FILE *fp;
	int r;
	int tx, ty;
	int n, k;
	int x, y, z;
	int b1, b2;

	fp = fopen("banana.in", "rt");
	fscanf(fp, "%d%d", &n, &k);
	for(x = 0; x < n; x++) {
		fscanf(fp, "%d%d", &tx, &ty);
		xc[x] = tx; yc[x] = ty;
		bndx[x] = x;
	}
	fclose(fp);

	mergesortb(bndx, n);

	ds_init();

	for(x = 1; x < n; x++) {
		b1 = bb_find(xc[bndx[x]], yc[bndx[x]] - 1, x);
		b2 = bb_find(xc[bndx[x]] - 1, yc[bndx[x]], x);
		if(b1 != -1)
			ds_union(x, b1);
		if(b2 != -1)
			ds_union(x, b2);
	}

	for(x = 0; x < n; x++)
		gcc[ds_find(x)]++;
	mergesortx(gcc, n);

	r = 0;
	for(x = 0; x < k; x++)
		r += gcc[n - x - 1];

	fp = fopen("banana.out", "wt");
	fprintf(fp, "%d\n", r);
	fclose(fp);

	return 0;
}