#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <time.h>

extern unsigned _stklen = 50000U;

#define MAX 16000

int n, k, nrcomp, answer;

int *x, *y, *indexx, *indexy, *nrb, *v, *indexxx, *indexyy;

int comparex(const void *, const void *);
int comparey(const void *, const void *);
int compare(const void *, const void *);
void explore(int);

int main(void)
{
//	clock_t start = clock();
	FILE *fin, *fout;
	int i, ind, temp;

	randomize();

	indexxx = (int *)malloc(MAX * sizeof(int));
	indexyy = (int *)malloc(MAX * sizeof(int));
	indexx = (int *)malloc(MAX * sizeof(int));
	indexy = (int *)malloc(MAX * sizeof(int));
	v = (int *)malloc(MAX * sizeof(int));
	x = (int *)malloc(MAX * sizeof(int));
	y = (int *)malloc(MAX * sizeof(int));

	fin = fopen("banana.in", "r");
	fscanf(fin, "%d %d", &n, &k);
	for (i = 0; i < n; i++)
		fscanf(fin, "%d %d", &x[i], &y[i]);
	fclose(fin);

	for (i = 0; i < n; i++)
	{
		ind = random(n);
		temp = x[i];
		x[i] = x[ind];
		x[ind] = temp;
		temp = y[i];
		y[i] = y[ind];
		y[ind] = temp;
	}

	for (i = 0; i < n; i++)
		indexx[i] = i;
	qsort(indexx, n, sizeof(int), &comparex);
	for (i = 0; i < n; i++)
		indexxx[indexx[i]] = i;
	for (i = 0; i < n; i++)
		indexy[i] = i;
	qsort(indexy, n, sizeof(int), &comparey);
	for (i = 0; i < n; i++)
		indexyy[indexy[i]] = i;

	for (i = 0; i < n; i++)
		v[i] = -1;

/*	printf("Indexxx: ");
	for (i = 0; i < n; i++)
		printf("%d ", indexxx[i]);
	printf("\n");

	printf("Indexyy: ");
	for (i = 0; i < n; i++)
		printf("%d ", indexyy[i]);
	printf("\n");

	printf("Indexx: ");
	for (i = 0; i < n; i++)
		printf("%d ", indexx[i]);
	printf("\n");

	printf("Indexy: ");
	for (i = 0; i < n; i++)
		printf("%d ", indexy[i]);
	printf("\n");*/

	nrcomp = 0;
	for (i = 0; i < n; i++)
		if (v[i] == -1)
		{
			explore(i);
			nrcomp++;
		}

	free(indexx);
	free(indexy);
	free(indexxx);
	free(x);
	free(y);
	free(indexyy);

	nrb = (int *)malloc(MAX * sizeof(int));

	for (i = 0; i < n; i++)
		nrb[i] = 0;
	for (i = 0; i < n; i++)
		nrb[v[i]]++;

	qsort(nrb, nrcomp, sizeof(int), &compare);

	answer = 0;
	for (i = 0; i < k; i++)
		answer += nrb[i];

	fout = fopen("banana.out", "w");
	fprintf(fout, "%d\n", answer);
	fclose(fout);

	free(v);
	free(nrb);

//	printf("The time was: %f\n", (clock() - start) / CLK_TCK);
	return 0;
}

int comparex(const void *a, const void *b)
{
	int *pa = (int *)a, *pb = (int *)b;

	if (x[*pa] < x[*pb])
		return -1;
	if (x[*pa] > x[*pb])
		return 1;
	if (y[*pa] < y[*pb])
		return -1;
	if (y[*pa] > y[*pb])
		return 1;
	return 0;
}

int comparey(const void *a, const void *b)
{
	int *pa = (int *)a, *pb = (int *)b;

	if (y[*pa] < y[*pb])
		return -1;
	if (y[*pa] > y[*pb])
		return 1;
	if (x[*pa] < x[*pb])
		return -1;
	if (x[*pa] > x[*pb])
		return 1;
	return 0;
}

void explore(int nod)
{
	int next, q[MAX], cap, coada;

	cap = 0;
	coada = 1;
	q[cap] = nod;
	v[nod] = nrcomp;

	while (cap < coada)
	{
		nod = q[cap++];
		if (indexxx[nod] - 1 >= 0)
		{
			next = indexx[indexxx[nod] - 1];
			if (v[next] == -1 && y[next] == y[nod] - 1 && x[next] == x[nod])
			{
				q[coada++] = next;
				v[next] = nrcomp;
			}
		}
		if (indexxx[nod] + 1 < n)
		{
			next = indexx[indexxx[nod] + 1];
			if (v[next] == -1 && y[next] == y[nod] + 1 && x[next] == x[nod])
			{
				q[coada++] = next;
				v[next] = nrcomp;
			}
		}
		if (indexyy[nod] + 1 < n)
		{
			next = indexy[indexyy[nod] + 1];
			if (v[next] == -1 && x[next] == x[nod] + 1 && y[next] == y[nod])
			{
				q[coada++] = next;
				v[next] = nrcomp;
			}
		}
		if (indexyy[nod] - 1 >= 0)
		{
			next = indexy[indexyy[nod] - 1];
			if (v[next] == -1 && x[next] == x[nod] - 1 && y[next] == y[nod])
			{
				q[coada++] = next;
				v[next] = nrcomp;
			}
		}
	}
}

int compare(const void *a, const void *b)
{
	int *pa = (int *)a, *pb = (int *)b;

	if (*pa > *pb)
		return -1;
	else
		return 1;
}
