{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65000,0,655360}

program banana;
type ttdata=array[1..16000] of integer;
     tdata=^ttdata;
var nr,k:integer;

    { The coordonates for every tree }
    coordX,coordY:tdata;

    { No. of elements from each area }
    noEl:tdata;
    indexNoEl:integer;

    { ID of the area for every tree }
    area:tdata;

    i,j,pivot,pivot2,aux:integer;
    noImportant:integer;

    current:integer;

    c1, c2:integer;

    cache, a, b:integer;

procedure reunion(a, b:integer);
var d:integer;
begin
     noEl^[a] := noEl^[a]+noEl^[b];
     noEl^[b] := 0;

     for d := noImportant to current do
     begin
          if area^[d] = b then
          begin
               area^[d] := a;
          end;
     end;
end;

procedure updateImportant;
begin
     while (coordX^[noImportant] + 1 < coordX^[current]) or
           ((coordX^[noImportant] + 1 = coordX^[current]) and (coordY^[noImportant] < coordY^[current])) do
     begin
          inc(noImportant);
     end;
end;

function qsort2_g(x:integer):boolean;
begin
     if (coordX^[x] > pivot) or
        ((coordX^[x] = pivot) and (coordY^[x] > pivot2)) then
     begin
          qsort2_g := true;
     end else
     begin
          qsort2_g := false;
     end;
end;

function qsort2_l(x:integer):boolean;
begin
     if (coordX^[x] < pivot) or
        ((coordX^[x] = pivot) and (coordY^[x] < pivot2)) then
     begin
          qsort2_l := true;
     end else
     begin
          qsort2_l := false;
     end;
end;

procedure qsort2(l, r:integer);
begin
     i := l;
     j := r;
     pivot := coordX^[(l + r) div 2];
     pivot2 := coordY^[(l + r) div 2];
     repeat
           while qsort2_l(i) do
           begin
                inc(i);
           end;
           while qsort2_g(j) do
           begin
                dec(j);
           end;
           if i <= j then
           begin
                aux := coordX^[i];
                coordX^[i] := coordX^[j];
                coordX^[j] := aux;

                aux := coordY^[i];
                coordY^[i] := coordY^[j];
                coordY^[j] := aux;

                inc(i);
                dec(j);
           end;
     until i > j;
     if l < j then qsort2(l, j);
     if i < r then qsort2(i, r);
end;

procedure qsort(l, r:integer);
begin
     i := l;
     j := r;
     pivot := noEl^[(l + r) div 2];
     repeat
           while (noEl^[i] < pivot) do
           begin
                inc(i);
           end;
           while (noEl^[j] > pivot) do
           begin
                dec(j);
           end;
           if i <= j then
           begin
                aux := noEl^[i];
                noEl^[i] := noEl^[j];
                noEl^[j] := aux;
                inc(i);
                dec(j);
           end;
     until i > j;
     if l < j then qsort(l, j);
     if i < r then qsort(i, r);
end;

procedure readData;
var f:text;
    d:integer;
begin
     assign(f, 'banana.in');
     reset(f);
     readln(f, nr, k);
     for d := 1 to nr do
     begin
          readln(f, coordX^[d], coordY^[d]);
     end;
     close(f);
end;

procedure initData;
begin
     new(coordX);
     new(coordY);
     new(area);
     new(noEl);
     indexNoEl := 0;
end;

procedure setConditions;
begin
     c1 := 0;
     c2 := 0;

     if (coordX^[noImportant] + 1 = coordX^[current]) and
        (coordY^[noImportant] = coordY^[current]) then
     begin
          c1 := 1;
     end;

     if (coordX^[current - 1] = coordX^[current]) and
        (coordY^[current - 1] + 1 = coordY^[current]) then
     begin
          c2 := 1;
     end;
end;

procedure solveSquare;
var d:integer;
begin
     updateImportant;
     setConditions;

     if (c1 = 0) and (c2 = 0) then
     begin
          inc(indexNoEl);
          area^[current] := indexNoEl;
          noEl^[indexNoEl] := 1;
     end;

     if (c1 = 1) and (c2 = 0) then
     begin
          cache := area^[noImportant];
          inc(noEl^[cache]);
          area^[current] := cache;
     end;

     if (c1 = 0) and (c2 = 1) then
     begin
          cache := area^[current - 1];
          inc(noEl^[cache]);
          area^[current] := cache;
     end;

     if (c1 = 1) and (c2 = 1) then
     begin
          a := area^[noImportant];
          b := area^[current - 1];
          area^[current] := b;
          inc(noEl^[b]);
          reunion(a, b);
     end;
end;

procedure solve;
var d:integer;
begin
     qsort2(1, nr);

     noImportant := 1;
     indexNoEl := 1;
     area^[1] := 1;
     noEl^[1] := 1;

     for current := 2 to nr do
     begin
          solveSquare;
     end;
end;

procedure writeData;
var f:text;
    sum:longint;
    d:integer;
    r:integer;
begin
     assign(f, 'banana.out');
     rewrite(f);
     qsort(1, indexNoEl);
     sum := 0;
     r := indexNoEl - k + 1;
     if r < 1 then
     begin
          r := 1;
     end;
     for d := indexNoEl downto r do
     begin
          inc(sum, noEl^[d]);
     end;
     write(f, sum);
     close(f);
end;

procedure disposeData;
begin
     dispose(coordX);
     dispose(coordY);
     dispose(noEl);
     dispose(area);
end;

begin
     initData;
     readData;
     solve;
     writeData;
     disposeData;
end.