{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65000,0,655360}
program gard;

const MAX_K = 100;
      MAX_N = 16000;

type  ttNint = array[0..MAX_N] of integer;
      ttNlong = array[0..MAX_N] of longint;
      tNint = ^ttNint;
      tNlong = ^ttNlong;

var l:array[1..MAX_K] of integer;
    p:array[1..MAX_K] of integer;
    s:array[1..MAX_K] of integer;
    ls:array[1..MAX_K] of integer;

    started:array[1..MAX_K] of integer;
    ended:array[1..MAX_K] of integer;

    n, k:integer;

    memoLeft:tNlong;
    memoRight:tNlong;
    back:tNint;
    worker:tNint;

    sol:longint;
    beneficiu:longint;
    pivot, pivot2, aux:integer;

    current, dest, dest2:integer;

    oldD, oldDest, oldDest2:integer;

procedure initData;
begin
     new(memoLeft);
     new(memoRight);
     new(back);
     new(worker);
     fillchar(memoLeft^, sizeof(memoLeft^), 0);
     fillchar(memoRight^, sizeof(memoRight^), 0);
     fillchar(worker^, sizeof(worker^), 0);
     fillchar(back^, sizeof(back^), 0);
     sol := 0;
end;

procedure readData;
var f:text;
    d:integer;
begin
     assign(f, 'gard.in');
     reset(f);
     readln(f, n, k);
     for d:=1 to k do
     begin
          readln(f, l[d], p[d], s[d]);
          ls[d] := s[d] + 1 - l[d];
          if ls[d] < 1 then
          begin
               ls[d] := 1;
          end;
     end;
     close(f);
end;

procedure addBeneficiu(x:integer);
begin
     if (x > 0) and (x <= n) then
     begin
          inc(beneficiu, p[current]);
     end;
end;

procedure substractBeneficiu(x:integer);
begin
     if (x > 0) and (x <= n) then
     begin
          dec(beneficiu, p[worker^[x]]);
     end;
end;

procedure deduct(d:integer);
var temp, r:integer;
begin
     while d < dest2 do
     begin
          temp := back^[dest2 - 1] + 1;
          if temp <> 1 then
          begin
               for r := dest2 - 1 downto temp do
               begin
                    substractBeneficiu(r);
               end;
               dest2 := temp;
          end else
          begin
               dest2 := d;
          end;
     end;
end;

procedure startPainting(d:integer);
var r:integer;
    beneficiu:longint;
begin
     dest := d;
     beneficiu := 0;
     addBeneficiu(d);
     substractBeneficiu(d);
     dest2 := d;
     while (d + 1 - dest <= l[current]) and (dest > 0) do
     begin
          deduct(dest);
          if memoLeft^[dest - 1] + memoRight^[d + 1] + p[current] * (d + 1 - dest) > sol then
          begin
               sol := memoLeft^[dest - 1] + memoRight^[d + 1] + p[current] * (d + 1 - dest);
               oldD := d;
               oldDest := dest;
               oldDest2 := dest2;
          end;
          dec(dest);
          addBeneficiu(dest);
     end;
end;

procedure writeSolWorker;
var r:integer;
begin
     for r := oldD downto oldDest do
     begin
          worker^[r] := current;
          back^[r] := oldDest - 1;
          memoLeft^[r] := memoLeft^[oldDest - 1] + (r + 1 - oldDest) * p[current];
          memoRight^[r] := memoRight^[oldD + 1] + (oldD + 1 - r) * p[current];
     end;
     for r := oldDest - 1 downto oldDest2 do
     begin
          worker^[r] := 0;
          back^[r] := 0;
          memoLeft^[r] := memoLeft^[oldDest2 - 1];
          memoRight^[r] := memoRight^[oldDest];
     end;
end;

procedure solveWorker;
var lr, d, r:integer;
begin
     oldD := -1;

     lr := s[current] - 1 + l[current];

     if lr > n then
     begin
          lr := n;
     end;

     if p[worker^[s[current]]] = p[current] then
     begin
          startPainting(s[current]);
     end;

     for d := s[current] to lr do
     begin
          if p[worker^[d]] < p[current] then
          begin
               startPainting(d);
          end;
     end;

     if oldD <> -1 then
     begin
          writeSolWorker;
     end;
end;

procedure qsort(lft, r:integer);
var i, j:integer;
begin
     i := lft;
     j := r;
     pivot := ls[(lft + r) div 2];
     pivot2 := p[(lft + r) div 2];
     repeat
           while (ls[i] < pivot) or ((ls[i] = pivot) and (p[i] > pivot2)) do
           begin
                inc(i);
           end;
           while (ls[j] > pivot) or ((ls[j] = pivot) and (p[j] < pivot2)) do
           begin
                 dec(j);
           end;
           if i <= j then
           begin
                aux := l[i];
                l[i] := l[j];
                l[j] := aux;

                aux := p[i];
                p[i] := p[j];
                p[j] := aux;

                aux := s[i];
                s[i] := s[j];
                s[j] := aux;

                aux := ls[i];
                ls[i] := ls[j];
                ls[j] := aux;

                inc(i);
                dec(j);
           end;
     until i > j;
     if lft < j then qsort(lft, j);
     if i < r then qsort(i, r);
end;

procedure solve;
var d:integer;
begin
     qsort(1, k);
     for current := 1 to k do
     begin
          solveWorker;
     end;
end;

procedure writeData;
var f:text;
begin
     assign(f,'gard.out');
     rewrite(f);
     writeln(f, sol);
     close(f);
 end;

procedure disposeData;
begin
     dispose(worker);
     dispose(back);
     dispose(memoLeft);
     dispose(memoRight);
end;

begin
     initData;
     readData;
     solve;
     writeData;
     disposeData;
end.
